/************************************************
* CATCHINT - Show how to use PRVs and a faked	*
* argument list to access register values for	*
* an ISR routine.								*
*												*
* 900316 MCMason - The Cobb Group, Inc.			*
************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <dos.h>
#include <string.h>

void (interrupt far *OldInt60)(void);

void interrupt far NewInt60(int es,int ds,int di,
		int si,int bp,int sp,int bx,int dx,int cx,
		int ax,int ip,int cs,int fl)
	{
	puts("\nRegister values at time of Int 60:");
	printf("AX=%04x BX=%04x CX=%04x DX=%04x ",
			ax,		bx,		cx,		dx);
	printf("SI=%04x DI=%04x BP=%04x SP=%04x\n",
			si,		di,		bp,		sp);
	printf("CS=%04x DS=%04x ES=%04x SS=???? ",
			cs,		ds,		es);
	printf("IP=%04x FL=%04x\n",ip,fl);
	}

void main(void)
	{
	union REGS r;
	struct SREGS s;

	/* Install the Interrupt 60 monitor routine	*/
	OldInt60 = _dos_getvect(0x60);
	_dos_setvect(0x60,NewInt60);

	/* Call interrupt 60 with some known numbers*/
	r.x.ax=0x1234; r.x.bx=0x2345; r.x.cx=0x3456;
	r.x.dx=0x4321; r.x.si=0x1357; r.x.di=0x7351;
	segread(&s);
	s.ds=0x9ac2; s.es=0xac13; s.cs=0xfabb;

	puts("Call Int 60H with known register vals");
	int86x(0x60,&r,&r,&s);
	puts("Back from Int 60H");

	/* Remove the Interrupt 60 monitor routine	*/
	_dos_setvect(0x60,OldInt60);
	}
